import pygtk, gtk
pygtk.require('2.0')
from os import path, mkdir, listdir, remove
from pango import ELLIPSIZE_END
from zipfile import ZipFile, is_zipfile
from shutil import move, rmtree
from winmodules import *

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, nametheme, trwin):

    
    def save_changes(widget, trwin):
        #Save all changes into variables
        print 'Saving changes...'
        
        globalconfig.set('PREFERENCES','ign_high', int(checkh.get_active()))
        globalconfig.set('PREFERENCES','ign_med', int(checkm.get_active()))
        globalconfig.set('PREFERENCES','ign_low', int(checkl.get_active()))
        globalconfig.set('PREFERENCES','heur_ac', int(checkhe.get_active()))
        
        #Save profiles
        it = liststore.get_iter_first()
        globalconfig.set('USER','profiles','')
        
        #Get names and paths
        while it:
          globalconfig.set('USER','profiles', globalconfig.get('USER','profiles') + liststore.get_value(it,1) + '|' + liststore.get_value(it,2) + '||')
          it = liststore.iter_next(it)
        
        #Save scan log settings
        globalconfig.set('PREFERENCES', 'wrlog', int(wrlog.get_active()))
        globalconfig.set('PREFERENCES', 'wrdet', int(wrdet.get_active()))
        globalconfig.set('PREFERENCES', 'wrback', int(wrbackup.get_active()))
        globalconfig.set('PREFERENCES', 'max_logs', int(adjustment.get_value()))

        #Rewrite configuration
        globalconfig.write(open('etc/gconfig.cfg','w'))
        gtk.Widget.destroy(trwin)
        
    
    def add_profile(widget):
        #File chooser
        filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = unicode(filebrowser.get_filename())
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_1'), win, languageconfig.get('PRWINDOW','error_title'))
            elif not "cookies.sqlite" in selected:
                show_error(languageconfig.get('PRWINDOW','error_2'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                it = liststore.get_iter_first()
                while it:
                    if liststore.get_value(it,2) != selected:
                       it = liststore.iter_next(it)
                    else:
                       show_error(languageconfig.get('PRWINDOW','error_6'), win, languageconfig.get('PRWINDOW','error_title'))
                       break
                else:
                     make_profilelist(None, 1, (path.basename(path.dirname(selected)), selected))
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()
    
    
    def make_profilelist(widget, refresh, new_profile=None):
        #If liststore has changed, update it...
        if refresh:
           liststore.append([gtk.gdk.pixbuf_new_from_file("%s/profile.png" % nametheme), new_profile[0], new_profile[1]])
        #Else make it all
        else:
            profilelist = globalconfig.get('USER','profiles')
            profilelist = profilelist.split('||')
            del profilelist[-1]
            for profile in profilelist:
                liststore.append([gtk.gdk.pixbuf_new_from_file("%s/profile.png" % nametheme), profile.split('|')[0], profile.split('|')[1]])
    
    def cursor_changed(widget, type, *items):
        if type == 0:
            global cursorpos
            cursorpos = treeview.get_cursor()[0][0]
        elif type == 1:
            global cursorpos2
            cursorpos2 = treeviewlang.get_cursor()[0][0]
        elif type == 2:
            global cursorpos3
            cursorpos3 = treeviewtheme.get_cursor()[0][0]
        
    def remove_item(widget, type, *items):
        if type == 0:
            global cursorpos
        
            #Remove from liststore selected row
            if cursorpos != None:
                liststore.remove(liststore.get_iter(int(cursorpos)))
                cursorpos = None
           
        
    def wrlog_togg(*items):
        #Toggle check buttons
        wrlog.get_active()
        wrdet.set_sensitive(wrlog.get_active())
        logs.set_sensitive(wrlog.get_active())
        
    def clear_log(*items):
        #Clear log
        #Save backup if needed
        if wrbackup.get_active():
            open('etc/scan_log.txt.bk','w').write(open('etc/scan_log.txt','r').read())
        logfile = open('etc/scan_log.txt','w')
        logfile.flush()
        logfile.close()
        
        #Info Dialog
        adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_log'))
        adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_log'))
        adv.set_modal(True)
        adv.set_transient_for(win)
        adv.show()
        resp = adv.run()
        if resp == gtk.RESPONSE_CLOSE:
            adv.destroy()
        adv.destroy()
        
    def heur_warning(*items):
        if checkhe.get_active():
           #Display warning
           adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_warning'))
           adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_warning'))
           adv.set_modal(True)
           adv.set_transient_for(win)
           adv.show()
           resp = adv.run()
           if resp == gtk.RESPONSE_CLOSE:
              adv.destroy()
           adv.destroy()
        else:
            pass
        
    #Preference Window
    
    #Start Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(410, 305)
    win.set_resizable(True)
    win.set_title(languageconfig.get('PRWINDOW','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Main Table
    maintable = gtk.Table(2, 2, False)
    
    #Notebook
    notebook = gtk.Notebook()
    notebook.set_tab_pos(gtk.POS_TOP)
    
    ##Scan Section
    ####
    
    #Section table
    prtable = gtk.Table(2, 4, False)
    
    #Scrolled window
    scrollwin = gtk.ScrolledWindow(None, None)
    scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    
    #Tree liststore
    liststore = gtk.ListStore(gtk.gdk.Pixbuf, str, str)
    
    #TreeView
    treeview = gtk.TreeView(liststore)
    treeview.set_rules_hint(True)
    treeview.connect("cursor-changed",cursor_changed,0)
    
    
    #Make profile list
    global cursorpos
    cursorpos = None
    make_profilelist(None, False)

    #TreeViewColums
    columnpix = gtk.TreeViewColumn()
    columnstr = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_top'))
    columnstr2 = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_path'))
    
    #Append columns
    treeview.append_column(columnpix)
    treeview.append_column(columnstr)
    treeview.append_column(columnstr2)

    #Cellrenderers
    cellpix = gtk.CellRendererPixbuf()
    cellstr = gtk.CellRendererText()
    cellstr.set_property("ellipsize-set", True)
    cellstr.set_property("ellipsize", ELLIPSIZE_END)
    cellstr2 = gtk.CellRendererText()
    cellstr2.set_property("ellipsize-set", True)
    cellstr2.set_property("ellipsize", ELLIPSIZE_END)

    #Add cell renderers
    columnpix.pack_start(cellpix, True)
    columnstr.pack_start(cellstr, True)
    columnstr.set_resizable(True)
    columnstr2.pack_start(cellstr2, True)

    #Set attributes
    columnpix.set_attributes(cellpix, pixbuf=0)
    columnstr.set_attributes(cellstr, text=1)
    columnstr2.set_attributes(cellstr2, text=2)
    cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Add TreeView to ScrolledWin
    scrollwin.add(treeview)

    #Label Profiles
    proflab = gtk.Label(' ' + languageconfig.get('PRWINDOW','label_profile'))
    
    #Remove profile button
    removebox = gtk.HBox(False, 0)
    removeimage = gtk.Image()
    removeimage.set_from_file('%s/clear.png' % nametheme)
    removelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','removepr_lab'))
    removebox.pack_start(removeimage, False, 1)
    removebox.pack_start(removelab, True, 1)
    removebut = gtk.Button()
    removebut.add(removebox)
    removebut.connect('clicked',remove_item, 0)
    
    #Add profile button
    addbox = gtk.HBox(False, 0)
    addimage = gtk.Image()
    addimage.set_from_file('%s/add_new.png' % nametheme)
    addlab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','addpr_lab'))
    addbox.pack_start(addimage, False, 1)
    addbox.pack_start(addlab, True, 1)
    addbut = gtk.Button()
    addbut.add(addbox)
    addbut.connect('clicked',add_profile)
    
    #Button box
    pbox = gtk.HBox(False, 0)
    pbox.pack_start(removebut, False, 1)
    pbox.pack_start(addbut, False, 1)
    
    #HSeparator
    sep = gtk.HSeparator()
    
    #Frame(Infections filter) Container
    frame = gtk.Frame(languageconfig.get('PRWINDOW','frame_label'))
    frame.set_label_align(0.9, 0.5)
    
    
    #Check buttons
    checkh = gtk.CheckButton(languageconfig.get('PRWINDOW','check_high'))
    checkh.set_active(int(globalconfig.get('PREFERENCES', 'ign_high')))
    checkm = gtk.CheckButton(languageconfig.get('PRWINDOW','check_medium'))
    checkm.set_active(int(globalconfig.get('PREFERENCES', 'ign_med')))
    checkl = gtk.CheckButton(languageconfig.get('PRWINDOW','check_low'))
    checkl.set_active(int(globalconfig.get('PREFERENCES', 'ign_low')))
    checkhe = gtk.CheckButton(languageconfig.get('PRWINDOW','check_heur'))
    checkhe.set_active(int(globalconfig.get('PREFERENCES', 'heur_ac')))
    checkhe.connect('toggled', heur_warning)
    
    #Check buttons VContainer
    vbox = gtk.VBox(False, 0)
    vbox.pack_start(checkh, False, 1)
    vbox.pack_start(checkm, False, 1)
    vbox.pack_start(checkl, False, 1)
    vbox.pack_start(checkhe, False, 1)
    
    #Add widgets -> frame
    frame.add(vbox)
                  
    #Attach elements
    prtable.attach(scrollwin, 0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL, 1)
    prtable.attach(proflab, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(pbox, 1, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(sep, 0, 2, 2, 3, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(frame, 0, 2, 3, 4, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanbox = gtk.HBox(False, 0)
    scanimage = gtk.Image()
    scanimage.set_from_file('%s/tab_scan.png' % nametheme)
    scanlab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scan_top'))
    scanimage.show()
    scanlab.show()
    scanbox.pack_start(scanimage, True, 1)
    scanbox.pack_start(scanlab, False, 1)
    
    
    ##Scan Log Section
    ####
    
    #Table
    scanlogtable = gtk.Table(3, 9, False)
    
    #Labels
    spaces = gtk.HSeparator()
    spaces2 = gtk.Label('\n')
    scanmax = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanmax_log') + ' '*3)
    
    #CheckButtons
    wrlog = gtk.CheckButton(languageconfig.get('PRWINDOW','wrlog'))
    wrlog.set_active(int(globalconfig.get('PREFERENCES','wrlog')))
    wrlog.connect('toggled',wrlog_togg)
    wrdet = gtk.CheckButton(languageconfig.get('PRWINDOW','wrdet'))
    wrdet.set_active(int(globalconfig.get('PREFERENCES','wrdet')))
    wrbackup = gtk.CheckButton(languageconfig.get('PRWINDOW','wrback'))
    wrbackup.set_active(int(globalconfig.get('PREFERENCES','wrback')))
    
    #HScale and adjustment
    adjustment = gtk.Adjustment(float(globalconfig.get('PREFERENCES', 'max_logs')), 1, 50, 0, 0, 0)
    logs = gtk.HScale(adjustment)
    logs.set_digits(0)
    
    #Toggle check buttons
    wrlog_togg()
    
    #Separators
    hssep = gtk.HSeparator()
    
    #Box Button Clear Log
    clearlbox = gtk.HBox(False, 0)
    clearlimage = gtk.Image()
    clearlimage.set_from_file('%s/clear.png' % nametheme)
    clearllab = gtk.Label(' ' + languageconfig.get('PRWINDOW','clear_log'))
    clearlbox.pack_start(clearlimage, False, 1)
    clearlbox.pack_start(clearllab, True, 1)
    clearlbut = gtk.Button()
    clearlbut.add(clearlbox)
    clearlbut.connect('clicked', clear_log)
    
    #Button box
    pppbox = gtk.HBox(False, 0)
    pppbox.pack_start(clearlbut, False, 1)
    
    #Attach
    scanlogtable.attach(spaces ,0, 3, 0, 1, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrlog ,0, 3, 1, 2, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrdet ,0, 3, 2, 3, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrbackup ,0, 3, 3, 4, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(spaces2 ,0, 3, 4, 5, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(logs ,2, 3, 5, 6, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(scanmax ,0, 2, 5, 6, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(hssep ,0, 3, 6, 7, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(pppbox ,0, 3, 7, 8, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanlogbox = gtk.HBox(False, 0)
    scanlogimage = gtk.Image()
    scanlogimage.set_from_file('%s/tab_scan.png' % nametheme)
    scanloglab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanlog_top'))
    scanlogimage.show()
    scanloglab.show()
    scanlogbox.pack_start(scanlogimage, True, 1)
    scanlogbox.pack_start(scanloglab, False, 1)
    
    #Append pages
    notebook.append_page(prtable, scanbox)
    notebook.append_page(scanlogtable, scanlogbox)
    
    #Buttons
    #Box Button Apply
    applybox = gtk.HBox(False, 0)
    applyimage = gtk.Image()
    applyimage.set_from_file('%s/apply.png' % nametheme)
    applylab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','apply_lab'))
    applybox.pack_start(applyimage, False, 1)
    applybox.pack_start(applylab, True, 1)
    applybut = gtk.Button()
    applybut.add(applybox)
    applybut.connect('clicked', save_changes, win)
   
    
    #Box Button Cancel
    cancbox = gtk.HBox(False, 0)
    cancimage = gtk.Image()
    cancimage.set_from_file('%s/deny.png' % nametheme)
    canclab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','cancel_lab'))
    cancbox.pack_start(cancimage, False, 1)
    cancbox.pack_start(canclab, True, 1)
    cancbut = gtk.Button()
    cancbut.add(cancbox)
    cancbut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Button box
    ppbox = gtk.HBox(False, 0)
    ppbox.pack_start(applybut, False, 1)
    ppbox.pack_start(cancbut, False, 1)
    
    #Attach
    maintable.attach(notebook ,0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND, 1)
    maintable.attach(ppbox ,0, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    
    
    win.add(maintable)
    win.show_all()
    
