import pygtk, gtk
pygtk.require('2.0')
from pango import ELLIPSIZE_END
from winmodules import *
from os import path
from webbrowser import open as open_url
from ConfigParser import NoOptionError
from time import localtime
from locale import getpreferredencoding
from pysqlite2 import dbapi2 as sqlite

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, defconfig, nametheme, trwin):
    
    def profiles_dialog(*items):
        
        def check_toggled(widget, iter, *items):
            #Toggle check button
            prostore.set_value(prostore.get_iter(iter),1, bool(int(prostore.get_value(prostore.get_iter(iter),1)) - 1))
        
        def select_all(*items):
            #Select all profiles
            it = prostore.get_iter_first()
            while it:
                prostore.set_value(it, 1, True)
                it = prostore.iter_next(it)
                
        def init_scan(*items):
            #Get profiles to scan
            it = prostore.get_iter_first()
            list = []
            while it:
                if prostore.get_value(it, 1):
                    list.append(unicode(prostore.get_value(it, 3)))
                else:
                    pass
                it = prostore.iter_next(it)
        
            #Raise error if no profiles were selected
            if not list:
                show_error(languageconfig.get('PRWINDOW','error_7'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                #Init scan
                gtk.Widget.destroy(prowin)
                scansbut.set_sensitive(False)
                scan(list)
                
          
            
        #Dialog window
        prowin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        prowin.set_position(gtk.WIN_POS_CENTER)
        prowin.connect("delete_event", delete_event)
        prowin.set_default_size(400, 200)
        prowin.set_resizable(True)
        prowin.set_title(languageconfig.get('WINSCANPROFILE','window_title'))
        prowin.set_modal(True)
        prowin.set_transient_for(win)
        
        #Table
        protable = gtk.Table(3, 2, False)
        
        #Scrolled window
        scrollwin = gtk.ScrolledWindow(None, None)
        scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
        
        #Tree liststore
        prostore = gtk.ListStore(gtk.gdk.Pixbuf, bool, str, str)
        profilelist = globalconfig.get('USER','profiles')
        profilelist = profilelist.split('||')
        del profilelist[-1]
        for profile in profilelist:
            prostore.append([gtk.gdk.pixbuf_new_from_file("%s/profile.png" % nametheme), 0, profile.split('|')[0], profile.split('|')[1]])

    
        #TreeView
        protreeview = gtk.TreeView(prostore)
        protreeview.set_rules_hint(True)

        #TreeViewColums
        procolumnpix = gtk.TreeViewColumn()
        procolumnstr = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_top'))
        procolumnstr.set_resizable(True)
        procolumnstr2 = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_path'))
        
        #Append columns
        protreeview.append_column(procolumnpix)
        protreeview.append_column(procolumnstr)
        protreeview.append_column(procolumnstr2)

        #Cellrenderers
        procellpix = gtk.CellRendererPixbuf()
        procellbool = gtk.CellRendererToggle()
        procellbool.set_property('activatable', True)
        procellbool.connect('toggled', check_toggled, iter)
        procellstr = gtk.CellRendererText()
        procellstr.set_property("ellipsize-set", True)
        procellstr.set_property("ellipsize", ELLIPSIZE_END)
        procellstr2 = gtk.CellRendererText()
        procellstr2.set_property("ellipsize-set", True)
        procellstr2.set_property("ellipsize", ELLIPSIZE_END)

        #Add cell renderers
        procolumnpix.pack_start(procellpix, True)
        procolumnpix.pack_start(procellbool, True)
        procolumnstr.pack_start(procellstr, True)
        procolumnstr.set_resizable(True)
        procolumnstr2.pack_start(procellstr2, True)

        #Set attributes
        procolumnpix.set_attributes(procellpix, pixbuf=0)
        procolumnpix.set_attributes(procellbool, active=1)
        procolumnstr.set_attributes(procellstr, text=2)
        procolumnstr2.set_attributes(procellstr2, text=3)
        procellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR) #Tree liststore
        
        #Start scan button
        startbox = gtk.HBox(False, 0)
        startimage = gtk.Image()
        startimage.set_from_file('%s/apply.png' % nametheme)
        startlab = gtk.Label(' '*2 + languageconfig.get('WINSCANPROFILE','start'))
        startbox.pack_start(startimage, False, 1)
        startbox.pack_start(startlab, True, 1)
        startbut = gtk.Button()
        startbut.add(startbox)
        startbut.connect('clicked', init_scan)
    
        #Close button
        closebox = gtk.HBox(False, 0)
        closeimage = gtk.Image()
        closeimage.set_from_file('%s/deny.png' % nametheme)
        closelab = gtk.Label(' '*2 + languageconfig.get('WINSCANPROFILE','close_lab'))
        closebox.pack_start(closeimage, False, 1)
        closebox.pack_start(closelab, True, 1)
        closebut = gtk.Button()
        closebut.add(closebox)
        closebut.connect_object("clicked", gtk.Widget.destroy, prowin)
    
        #Select all button
        selallbox = gtk.HBox(False, 0)
        selallimage = gtk.Image()
        selallimage.set_from_file('%s/select_all.png' % nametheme)
        selalllab = gtk.Label(' '*2 + languageconfig.get('WINSCANPROFILE','selall_lab'))
        selallbox.pack_start(selallimage, False, 1)
        selallbox.pack_start(selalllab, True, 1)
        selallbut = gtk.Button()
        selallbut.add(selallbox)
        selallbut.connect('clicked', select_all)
    
        #Button box
        lgbox = gtk.HBox(False, 0)
        lgbox.pack_start(closebut, False, 1)
        lgbox.pack_start(selallbut, False, 1)
        lgbox.pack_start(startbut, False, 1)
        
        #Attach elements
        scrollwin.add(protreeview)
        protable.attach(scrollwin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
        protable.attach(lgbox, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
        
        #Show window
        prowin.add(protable)
        prowin.show_all()
        
        
    def scan(filelist, *items):
       #Global variables
       global foundobj, filelisto, risk_list
       ignlist = (globalconfig.get('PREFERENCES','ign_high'), globalconfig.get('PREFERENCES','ign_med'), globalconfig.get('PREFERENCES', 'ign_low'))

       #Check if databases are accessible
       success = 1
       totcookies = 0
       progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_connecting')))

       #The next step may take a while, so we force a gui update here
       while gtk.events_pending():
            gtk.main_iteration(False)
            
       for filesql in filelist:
           try:
            conn = sqlite.connect(filesql)
            cur = conn.cursor()
            cur.execute("SELECT host, name FROM moz_cookies")
            totcookies += len(cur.fetchall())
            cur.close()
            conn.close()
           except:
               success = 0

       if success:
        
        #Evaluate scan progress
        #progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_evaluate')))
            
        filelisto = filelist
        
        #Start scan
        fileid = -1
        foundobj = []
        risk_list = []
        if int(globalconfig.get('PREFERENCES', 'heur_ac')):
            keys_list = defconfig.get('HEUR', 'keys').split(';')
            keys_ignore = defconfig.get('HEUR', 'keys_i')[0:-1].split(';')
            
        
        for filesql in filelist:
            pointer = 0
            fileid += 1

            #Check wheter firefox is running
            conn = sqlite.connect(filesql)
            cur = conn.cursor()
            cur.execute("SELECT host, name FROM moz_cookies")
            
            for cookie in cur.fetchall():
                    #Update progress bar
                    progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_scanning').replace('%cookiename', cookie[1])))
                    
                    #Check whether the cookie is present in the black list
                    if defconfig.has_option('BLACKLIST', cookie[0]):
                        #Check whether ignore the cookie
                        if bool(int(ignlist[int(defconfig.get('BLACKLIST', cookie[0])) - 2])):
                            #Ignore this cookie
                            statstore.set_value(statstore.get_iter(6), 1, statstore.get_value(statstore.get_iter(6), 1) + 1)
                        else:
                            
                            #Cookie spec: file, line, thread, type(1 = risk object), priority, name
                            if int(defconfig.get('BLACKLIST', cookie[0])) == 2: priority = languageconfig.get('WINSCAN', 'p_h') 
                            if int(defconfig.get('BLACKLIST', cookie[0])) == 3: priority = languageconfig.get('WINSCAN', 'p_m') 
                            if int(defconfig.get('BLACKLIST', cookie[0])) == 4: priority = languageconfig.get('WINSCAN', 'p_l') 
                            foundobj.append([fileid, pointer, cookie[0], 0, priority, cookie[1]])
                         
                            #Add cookie found
                            statstore.set_value(statstore.get_iter(0), 1, statstore.get_value(statstore.get_iter(0), 1) + 1)
                            statstore.set_value(statstore.get_iter(int(defconfig.get('BLACKLIST', cookie[0]))), 1, statstore.get_value(statstore.get_iter(int(defconfig.get('BLACKLIST', cookie[0]))), 1) + 1)
                        
                    else:
                        #If heuristic is enabled, check for risk objects
                        if int(globalconfig.get('PREFERENCES', 'heur_ac')):
                           for x in range(len(keys_list) - 1):
                               if keys_list[x] in cookie[0]:
                                 #Check whether to ignore the cookie
                                 if not cookie[0] in keys_ignore:
							      
                                   #Add risk object
                                   foundobj.append([fileid, pointer, cookie[0], 1, languageconfig.get('WINSCAN', 'p_i') , cookie[1]])
                                   if not cookie[0] in risk_list: risk_list.append(cookie[0])
                                   statstore.set_value(statstore.get_iter(0), 1, statstore.get_value(statstore.get_iter(0), 1) + 1)
                                   statstore.set_value(statstore.get_iter(5), 1, statstore.get_value(statstore.get_iter(5), 1) + 1)
								   
                               else:
                                   pass
                               
                        else:
                           pass
                    
                    #Add cookie checked
                    statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)

                 
                    #Set progress
                    pointer += 1
                    bar1.set_fraction(float(statstore.get_value(statstore.get_iter(1), 1)) / totcookies)
                    prog = str(float(statstore.get_value(statstore.get_iter(1), 1)) / totcookies)
                    prog = prog[0:prog.find('.')] + prog[prog.find('.') + 1:4]
                    if len(prog) < 3: prog += '0'
                    if prog[0] == '0': prog = prog[1:]
                    bar1.set_text(prog + '%')
                
                    while gtk.events_pending():
                      gtk.main_iteration(False)

        #Update stats
        globalconfig.set('GENERAL', 'num_scans', int(globalconfig.get('GENERAL', 'num_scans')) + 1)
        globalconfig.set('GENERAL', 'num_found_obj', int(globalconfig.get('GENERAL', 'num_found_obj')) + int(statstore.get_value(statstore.get_iter(0), 1)))
        globalconfig.write(open('etc/gconfig.cfg', 'w'))
        
        #Enable buttons
        finbut.set_sensitive(True)
        closebut.set_sensitive(False)

        ##If objects were found
        if int(statstore.get_value(statstore.get_iter(0), 1)) > 0:
           rmbut.set_sensitive(True)
        
        #Update progress lab
        progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_end')))

        #Write eventlog
        write_eventlog('opt_s', 'scan_succ')

        #Write scanlog if necessary
        if int(globalconfig.get('PREFERENCES', 'wrlog')):
            maxlogs = int(globalconfig.get('PREFERENCES', 'max_logs'))
            #Open scanlog
            scanlogf = open('etc/scan_log.txt','r')
            if len(scanlogf.read().split('*' + '-'*15 + '*\n\n')) <= maxlogs:
                scanlogout = open('etc/scan_log.txt','a')
            else:
                scanlogout = open('etc/scan_log.txt','w')

            #Compile details
            new_contents = []
            dates = localtime()
            new_contents.append('::SCAN DETAILS::\n\n')
            new_contents.append('Date:: %s/%s/%s\n' % (dates[2], dates[1], dates[0]))
            new_contents.append('Time:: %s:%s:%s\n' % (dates[3], dates[4], dates[5]))
            new_contents.append('Objects found:: %s\n' % statstore.get_value(statstore.get_iter(0), 1))
            new_contents.append('Low Objects found:: %s\n' % statstore.get_value(statstore.get_iter(4), 1))
            new_contents.append('Medium Objects found:: %s\n' % statstore.get_value(statstore.get_iter(3), 1))
            new_contents.append('High Objects found:: %s\n' % statstore.get_value(statstore.get_iter(2), 1))
            new_contents.append('Risk Objects found:: %s\n' % statstore.get_value(statstore.get_iter(5), 1))
            new_contents.append('Objects ignored:: %s\n' % statstore.get_value(statstore.get_iter(6), 1))
            new_contents.append('Cookies checked:: %s\n' % statstore.get_value(statstore.get_iter(1), 1))

            #If necessary, compile object details
            if int(globalconfig.get('PREFERENCES','wrdet')):
                new_contents.append('------\n::OBJECT DETAILS::\n\n')
                for object in foundobj:
                    new_contents.append('Name::%s\nLocation::%s\nPriority::%s\n\n' % (object[5], object[2], object[4]))
            
            
            new_contents.append('*' + '-'*15 + '*\n\n')

            #Write out
            scanlogout.writelines(new_contents)
            scanlogout.close()
            scanlogf.close()

       else:
           #We could not read all the sql files
           show_error(languageconfig.get('WINSCAN', 'error_firefox'), win, languageconfig.get('WINSCAN','error_title'))
           progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_idle')))
           scansbut.set_sensitive(True)

           
    def remove_tool(*items):
        
        def select_all(*items):
            #Select all items
            it, it2, it3 = 0, 0, 0
            count, count2, count3 = 1, 1, 1
            
            while count:
                try:
                    treestore.set_value(treestore.get_iter('%s' % (it)),1, True)
                except ValueError:
                    count = 0
                else:
                    count2 = 1
                    it2 = 0
                    while count2:
                        try:
                           treestore.set_value(treestore.get_iter('%s:%s' % (it, it2)),1, True)
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            while count3:
                                try:
                                    treestore.set_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1, True)
                                except ValueError:
                                    count3 = 0
                                it3 += 1
                        it2 += 1            
                it += 1
                          
        def remove_selected(*items):
            #Get all items selected
            global filelisto
            it, it2, it3 = 0, 0, 0
            count, count2, count3 = 1, 1, 1
            objectsel = []
            
            while count:
                try:
                    treestore.get_iter('%s' % (it))
                except ValueError:
                    count = 0
                else:
                    count2 = 1
                    it2 = 0
                    while count2:
                        try:
                           treestore.get_iter('%s:%s' % (it, it2))
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            while count3:
                                try:
                                    treestore.get_iter('%s:%s:%s' % (it, it2, it3))
                                except ValueError:
                                    count3 = 0
                                else:
                                    #Object selected
                                    if treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1) == True:
                                        #Origin, name, risk
                                        objectsel.append((treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),2), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),2), treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),3), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),4).split(';')))
                        
                                it3 += 1
                        it2 += 1            
                it += 1

            #Take trace of object removed (risk, high, medium, low)
            numrm = [0, 0, 0, 0]
            numrt = str(len(objectsel))
            
            if len(objectsel) > 0:        


                  for cookie in objectsel:
                      #Add trace and delete current object
                      if cookie[2] == languageconfig.get('WINSCAN','p_i'): numrm[0] += 1
                      elif cookie[2] == languageconfig.get('WINSCAN','p_h'): numrm[1] += 1
                      elif cookie[2] == languageconfig.get('WINSCAN','p_m'): numrm[2] += 1
                      elif cookie[2] == languageconfig.get('WINSCAN','p_l'): numrm[3] += 1

                      #connect and delete cookie
                      conn = sqlite.connect(filelisto[int(cookie[3][0])])
                      cur = conn.cursor()
                      details = (cookie[0], cookie[1])
                      cur.execute('DELETE FROM moz_cookies WHERE host=? AND name=?', details)
                      conn.commit()
                      cur.close()
                      conn.close()

                  #Update globalconfig
                  #print numrm
                  globalconfig.set('GENERAL', 'num_removed_obj', str(int(globalconfig.get('GENERAL', 'num_removed_obj')) + int(numrt)))
                  globalconfig.set('GENERAL', 'num_lfound_obj', str(int(globalconfig.get('GENERAL', 'num_lfound_obj')) + int(numrm[3])))
                  globalconfig.set('GENERAL', 'num_mfound_obj', str(int(globalconfig.get('GENERAL', 'num_mfound_obj')) + int(numrm[2])))
                  globalconfig.set('GENERAL', 'num_hfound_obj', str(int(globalconfig.get('GENERAL', 'num_hfound_obj')) + int(numrm[1])))
                  globalconfig.set('GENERAL', 'num_ifound_obj', str(int(globalconfig.get('GENERAL', 'num_ifound_obj')) + int(numrm[0])))
                  globalconfig.write(open('etc/gconfig.cfg','w'))
               
                  #Close all windows
                  gtk.Widget.destroy(rmwin)
                  gtk.Widget.destroy(win)
            else:
                show_error(languageconfig.get('WINREMOVE', 'error_object'), rmwin, languageconfig.get('WINREMOVE','error_title'))


        def select_all_r(*items):
            #Select all
            defiter = liststore.get_iter_first()
            while defiter:
                liststore.set_value(defiter, 1, True)
                defiter = liststore.iter_next(defiter)
            
        def check_toggled_r(widget, iter, *items):
            #Toggle check button
            liststore.set_value(liststore.get_iter(iter),1, bool(int(liststore.get_value(liststore.get_iter(iter),1)) - 1))
        
        def check_toggled(widget, iter, *items):
            #Toggle check button
            treestore.set_value(treestore.get_iter(iter),1, bool(int(treestore.get_value(treestore.get_iter(iter),1)) - 1))
            
            #Toggle true/false all childs
            status = treestore.get_value(treestore.get_iter(iter),1)
            iter = str(iter).split(':')
            count = 1
            count2 = 1
            it = 0
            it2 = 0
            
            if len(iter) == 1:
                while count:
                      try:
                          treestore.set_value(treestore.get_iter('%s:%s' % (iter[0], it)),1, status)
                      except ValueError:
                          count = 0
                      else:
                          count2 = 1
                          it2 = 0
                          while count2:
                              try:
                                 treestore.set_value(treestore.get_iter('%s:%s:%s' % (iter[0], it, it2)),1, status)
                              except ValueError:
                                  count2 = 0
                              else:
                                  it2 += 1
                      it += 1
            
            if len(iter) == 2:
                    count2 = 1
                    while count2:
                        try:
                            treestore.set_value(treestore.get_iter('%s:%s:%s' % (iter[0], iter[1], it2)),1, status)
                        except ValueError:
                            count2 = 0
                        else:
                            it2 += 1
                      
                      
        
        #Scan window
        global filelisto, foundobj, risk_list
        rmwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        rmwin.set_position(gtk.WIN_POS_CENTER)
        rmwin.connect("delete_event", delete_event)
        rmwin.set_default_size(491, 280)
        rmwin.set_resizable(True)
        rmwin.set_title(languageconfig.get('WINREMOVE','window_title'))
        rmwin.set_modal(True)
        rmwin.set_transient_for(win)

        #Notebook
        notebook = gtk.Notebook()
        notebook.set_tab_pos(gtk.POS_TOP)

        #Main table
        maintable = gtk.Table(2, 2, False)

        #Remove section
        ###
        
        #Table
        rmtable = gtk.Table(3, 5, False)
        
        #build Tree treestore
        parentlist = {}
        treestore = gtk.TreeStore(gtk.gdk.Pixbuf, bool, str, str, str)
        for object in foundobj:
            #Add file item
            it = 0
            count = 1
            while count:
                try: 
                  if str(treestore.get_value(treestore.get_iter(it), 4)) == str(object[0]):
                     break
                  else:
                     it += 1
                except ValueError:
                   count = 0
            else:
                parentlist[str(it)] = treestore.append(None, [gtk.gdk.pixbuf_new_from_file("%s/folder_up.png" % nametheme), None, path.basename(path.dirname(filelisto[object[0]])), '', str(object[0])])

            
            #Add url item
            count = 1
            it2 = 0
            while count:
                try:
                    if treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)), 2) == object[2]:
                        break
                    else:
                        it2 += 1
                except ValueError:
                    count = 0
                
            else:
                if object[3] == 0:
                    pixbuf = gtk.gdk.pixbuf_new_from_file("%s/folder.png" % nametheme)
                else:
                    pixbuf = gtk.gdk.pixbuf_new_from_file("%s/risk_folder.png" % nametheme)
                parentlist['%s:%s' % (it, it2)] = treestore.append(parentlist[str(it)], [pixbuf, None, object[2], object[4], '0'])
            
            #Add cookie item
            if object[3] == 0:
                pixbuf = gtk.gdk.pixbuf_new_from_file("%s/object.png" % nametheme)
            else:
                pixbuf = gtk.gdk.pixbuf_new_from_file("%s/object_risk.png" % nametheme)
            treestore.append(parentlist['%s:%s' % (it, it2)], [pixbuf, None, object[5], '', '%s;%s' % (object[0], object[1])])
       
        
        #TreeView
        treeview = gtk.TreeView(treestore)
        treeview.set_rules_hint(True)
        
        #TreeViewColums
        columnbool = gtk.TreeViewColumn(None)
        columnstr = gtk.TreeViewColumn(languageconfig.get('MAINWINDOW','index_name'))
        columnstr.set_resizable(True)
        columnstr2 = gtk.TreeViewColumn(languageconfig.get('WINSCAN','priority_name'))
        columnstr2.set_resizable(True)
        columnid = gtk.TreeViewColumn(None)
        columnid.set_visible(False)
        
        #Append columns
        treeview.append_column(columnbool)
        treeview.append_column(columnstr)
        treeview.append_column(columnstr2)
        treeview.append_column(columnid)
        
        #Cellrenderers
        cellpix = gtk.CellRendererPixbuf()
        cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
        cellbool = gtk.CellRendererToggle()
        cellbool.set_property('activatable', True)
        cellbool.connect('toggled', check_toggled, iter)
        cellstr = gtk.CellRendererText()
        cellstr.set_property("ellipsize-set", True)
        cellstr.set_property("ellipsize", ELLIPSIZE_END)
        cellstr2 = gtk.CellRendererText()
        cellstr2.set_property("ellipsize-set", True)
        cellstr2.set_property("ellipsize", ELLIPSIZE_END)
        cellid = gtk.CellRendererText()
        
        #Add cell renderers
        columnbool.pack_start(cellpix, True)
        columnbool.pack_start(cellbool, True)
        columnstr.pack_start(cellstr, True)
        columnstr2.pack_start(cellstr2, True)
        columnid.pack_start(cellid, True)
        
        #Set attributes
        columnbool.set_attributes(cellpix, pixbuf=0)
        columnbool.set_attributes(cellbool, active=1)
        columnstr.set_attributes(cellstr, text=2)
        columnstr2.set_attributes(cellstr2, text=3)
        columnid.set_attributes(cellid, text=4)
        
    	#Box Button Remove sel
	rmtbox = gtk.HBox(False, 0)
	rmtimage = gtk.Image()
	rmtimage.set_from_file('%s/remove_sel.png' % nametheme)
	rmtlab = gtk.Label('  ' + languageconfig.get('WINREMOVE','remove_lab'))
	rmtbox.pack_start(rmtimage, False, 1)
	rmtbox.pack_start(rmtlab, True, 1)
	rmtbut = gtk.Button()
	rmtbut.add(rmtbox)
	rmtbut.connect('clicked', remove_selected)
	
	#Box Button Select all
	seabox = gtk.HBox(False, 0)
	seaimage = gtk.Image()
	seaimage.set_from_file('%s/select_all.png' % nametheme)
	sealab = gtk.Label('  ' + languageconfig.get('WINREMOVE','select_all'))
	seabox.pack_start(seaimage, False, 1)
	seabox.pack_start(sealab, True, 1)
	seabut = gtk.Button()
	seabut.add(seabox)
	seabut.connect('clicked', select_all)
	
	#Box Button Close
	closebox = gtk.HBox(False, 0)
	closeimage = gtk.Image()
	closeimage.set_from_file('%s/deny.png' % nametheme)
	closelab = gtk.Label('  ' + languageconfig.get('WINREMOVE','close_lab'))
	closebox.pack_start(closeimage, False, 1)
	closebox.pack_start(closelab, True, 1)
	closebut = gtk.Button()
	closebut.add(closebox)
	closebut.connect_object("clicked", gtk.Widget.destroy, rmwin)
	
	#Label
	rmlabel = gtk.Label(languageconfig.get('WINREMOVE','remove_obj'))
	
	#Button box
	brbox = gtk.HBox(False, 0)
	brbox.pack_start(rmtbut, False, 1)
	brbox.pack_start(seabut, False, 1)
	brbox.pack_start(closebut, False, 1)
	
	#Scrolled Window
	swin = gtk.ScrolledWindow(None, None)
	swin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	swin.add(treeview)
	
	#Table show
	rmtable.attach(swin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	rmtable.attach(rmlabel, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
	rmtable.attach(brbox, 2, 3, 1, 2, gtk.FILL|gtk.FILL, gtk.FILL)

        #Remove label box
        removebox = gtk.HBox(False, 0)
        removeimage = gtk.Image()
        removeimage.set_from_file('%s/tab_remove.png' % nametheme)
        removelab = gtk.Label(' ' + languageconfig.get('WINREMOVE','remove_top'))
        removeimage.show()
        removelab.show()
        removebox.pack_start(removeimage, True, 1)
        removebox.pack_start(removelab, False, 1)


        #Append pages
        notebook.append_page(rmtable, removebox)

        #Attach final elements
        maintable.attach(notebook ,0, 2, 0, 2, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND, 1)
        
        #Add elements
        rmwin.add(maintable)
        rmwin.show_all()
    
    #Scan window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.set_position(gtk.WIN_POS_CENTER)
    win.connect("delete_event", delete_event)
    win.set_default_size(491, 270)
    win.set_resizable(True)
    win.set_title(languageconfig.get('WINSCAN','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Table
    table = gtk.Table(6, 3, False)
    
    #Separators
    hsep = gtk.HSeparator()
    hsep2 = gtk.HSeparator()
    
    #Progress bar
    bar1 = gtk.ProgressBar()
    bar1.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
    bar1.set_fraction(0.0)
    
    #Label 
    progresslab = gtk.Label() 
    progresslab.set_ellipsize(ELLIPSIZE_END)
    progresslab.set_text(':::%s: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_idle')))
                        
    #Box Button Close
    closebox = gtk.HBox(False, 0)
    closeimage = gtk.Image()
    closeimage.set_from_file('%s/deny.png' % nametheme)
    closelab = gtk.Label('  ' + languageconfig.get('WINSCAN','close_lab'))
    closebox.pack_start(closeimage, False, 1)
    closebox.pack_start(closelab, True, 1)
    closebut = gtk.Button()
    closebut.add(closebox)
    closebut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Box Button Scan
    scansbox = gtk.HBox(False, 0)
    scansimage = gtk.Image()
    scansimage.set_from_file('%s/start_scan.png' % nametheme)
    scanslab = gtk.Label('   ' + languageconfig.get('WINSCAN','scan_lab'))
    scansbox.pack_start(scansimage, False, 1)
    scansbox.pack_start(scanslab, True, 1)
    scansbut = gtk.Button()
    scansbut.add(scansbox)
    scansbut.connect('clicked', profiles_dialog)
    
    #Box Button Finish
    finbox = gtk.HBox(False, 0)
    finimage = gtk.Image()
    finimage.set_from_file('%s/finish.png' % nametheme)
    finlab = gtk.Label(' ' + languageconfig.get('WINSCAN','finish_lab'))
    finbox.pack_start(finimage, False, 1)
    finbox.pack_start(finlab, True, 1)
    finbut = gtk.Button()
    finbut.add(finbox)
    finbut.set_sensitive(False)
    finbut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Box Button Remove
    rmbox = gtk.HBox(False, 0)
    rmimage = gtk.Image()
    rmimage.set_from_file('%s/rmtool.png' % nametheme)
    rmlab = gtk.Label(' ' + languageconfig.get('WINSCAN','remove_lab'))
    rmbox.pack_start(rmimage, False, 1)
    rmbox.pack_start(rmlab, True, 1)
    rmbut = gtk.Button()
    rmbut.add(rmbox)
    rmbut.set_sensitive(False)
    rmbut.connect('clicked', remove_tool)
    
    #Button box
    bpbox = gtk.HBox(False, 0)
    bpbox.pack_start(closebut, False, 1)
    bpbox.pack_start(scansbut, False, 1)
    
    #Button box
    bpbox2 = gtk.HBox(False, 0)
    bpbox2.pack_start(finbut, False, 1)
    bpbox2.pack_start(rmbut, False, 1)
    
    #ListStore
    statstore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmfind.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_totfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/ocheck.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_totchecked')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmhigh.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_hfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmmed.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_mfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmlow.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_lfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmpot.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_potfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmignored.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_ignfound')])
    
    #TreeView
    foundobj, filelisto = None, None
    statview = gtk.TreeView(statstore)
    statview.set_rules_hint(True)
    statview.set_headers_clickable(False)
    
    
    #TreeViewColums
    columnum = gtk.TreeViewColumn('            ')
    columnum.set_resizable(True)
    columndet = gtk.TreeViewColumn(languageconfig.get('WINSCAN','top_scan') + ' ' * 10)
    columndet.set_resizable(True)
    
    #Append columns
    statview.append_column(columnum)
    statview.append_column(columndet)
    
    #Cellrenderers2
    cellimg = gtk.CellRendererPixbuf()
    cellnum = gtk.CellRendererText()
    celldet = gtk.CellRendererText()
    
    #add cell renderers
    columnum.pack_start(cellimg, True)
    columnum.pack_start(cellnum, True)
    columndet.pack_start(celldet, True)
    
    #set attributes
    columnum.set_attributes(cellimg, pixbuf=0)
    columnum.set_attributes(cellnum, text=1)
    columndet.set_attributes(celldet, text=2)
    cellimg.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Show 
    table.attach(statview, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
    table.attach(progresslab, 1, 3, 1, 2, gtk.FILL, gtk.FILL)
    table.attach(bar1, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
    table.attach(bpbox, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
    table.attach(hsep, 0, 3, 2, 3, gtk.FILL, 0)
    table.attach(bpbox2, 2, 3, 3, 4, gtk.FILL, gtk.FILL)
    table.attach(hsep2, 0, 3, 4, 5, gtk.FILL, 0)
    win.add(table)
    win.show_all()
    
    #Focus
    win.set_focus(None)
